#include <bits/stdc++.h>

#define ll long long
#define ld long double
#define sz(a) (int)a.size()
#define rep(i, l, r) for (int i = l; i < r; i++)
#define repb(i, l, r) for (int i = l; i > r; i--)
#define fi first
#define se second
#define prev askdkjasdvjgavds

using namespace std;

const int N = 5000000;
const int inf = (int)1e9 + 1;
const int MOD = (int)1e9 + 7;
const ll big = (ll)1e18 + 1;

template<class T>
void print(vector<T> s){
    for (int i = 0; i < s.size(); i++)
        cout << s[i] + 1 << " ";
    cout << endl;
}

template<class T>
void print(vector<pair<T, T> > s){
    for (int i = 0; i < s.size(); i++)
        cout << s[i].first << " " << s[i].second << endl;
    cout << endl;
}

template<class T>
void print(vector<vector<T> > s){
    for (int i = 0; i < s.size(); i++)
        print(s[i]);
    cout << endl;
}

int n, m;

struct edge
{
    int u, v, c, id;
    edge() {}
    edge(int u, int v, int c, int id) : u(u), v(v), c(c), id(id) {}
};

vector<edge> edges;

vector<int> g[N], gr[N];
int ccc;

void add_edge(int u, int v, int c, int id)
{
    g[u].push_back(id);
    edges.push_back(edge(u, v, c, sz(edges)));
}

int get_index(vector<int> &a, int x)
{
    int pos = lower_bound(a.begin(), a.end(), x) - a.begin();
    if (pos == sz(a) || a[pos] != x)
        return -1;
    else
        return pos;
}

void solve(int u)
{
    if (sz(g[u]) == 0)
        return;

    vector<int> diff_in;
    for (int e : gr[u])
        diff_in.push_back(edges[e].c);
    sort(diff_in.begin(), diff_in.end());
    diff_in.resize(unique(diff_in.begin(), diff_in.end()) - diff_in.begin());

    vector<int> diff_out;
    for (int e : g[u])
        diff_out.push_back(edges[e].c);
    sort(diff_out.begin(), diff_out.end());
    diff_out.resize(unique(diff_out.begin(), diff_out.end()) - diff_out.begin());
    //out
    vector<int> to_left, to_right;
    rep(i, 0, sz(diff_out))
    {
        if (i > 0)
            add_edge(ccc, ccc - 1, -1, sz(edges));
        to_left.push_back(ccc++);
    }
    repb(i, sz(diff_out) - 1, -1)
    {
        if (i < sz(diff_out) - 1)
            add_edge(ccc, ccc - 1, -1, sz(edges));
        to_right.push_back(ccc++);
    }
    for (int e : g[u])
    {
        int pos = get_index(diff_out, edges[e].c);
        add_edge(to_left[pos], edges[e].v, edges[e].c, edges[e].id);
        add_edge(to_right[pos], edges[e].v, edges[e].c, edges[e].id);
    }
    //in
    for (int e : gr[u])
    {
        int pos = get_index(diff_in, edges[e].c);
        edges[e].v = ccc + pos;
    }
    //in and out
    rep(i, 0, sz(diff_in))
    {
        int pos = get_index(diff_out, diff_in[i]);
        if (pos == -1)
            add_edge(ccc + i, to_right[0], -1, sz(edges));
        else
        {
            if (pos > 0)
                add_edge(ccc + i, to_left[pos - 1], -1, sz(edges));
            if (pos < sz(diff_out) - 1)
                add_edge(ccc + i, to_right[pos + 1], -1, sz(edges));
        }
    }
    ccc += sz(diff_in);
    g[u].clear();
}

int color[N];
int prev[N];
int prevEdge[N];

vector<int> was;

bool dfs(int v)
{
    was.push_back(v);
    color[v] = 1;
    for (int i : g[v]){
        if (color[edges[i].v] == 0){
            prev[edges[i].v] = v;
            prevEdge[edges[i].v] = edges[i].id;
            if (dfs(edges[i].v))
                return true;
            continue;
        }
        if (color[edges[i].v] == 1){
            int cur = v;
            vector<int> circle;
            if (edges[i].id < m)
                circle.push_back(edges[i].id);
            while (cur != edges[i].v){
                if (prevEdge[cur] < m)
                    circle.push_back(prevEdge[cur]);
                cur = prev[cur];
            }
            cout << circle.size() << "\n";
            reverse(circle.begin(), circle.end());
            print(circle);
            return true;
        }
    }
    color[v] = 2;
    return false;
}

int main()
{
    freopen("a.in", "r", stdin);
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int T;
    cin >> T;
    while (T--)
    {
        cin >> n >> m;
        rep(i, 0, ccc)
        {
            g[i].clear();
            gr[i].clear();
        }
        ccc = 0;
        edges.clear();
        rep(i, 0, m)
        {
            int u, v, c;
            cin >> u >> v >> c;
            u--; v--;
            edges.push_back(edge(u, v, c, i));
            g[u].push_back(i);
            gr[v].push_back(i);
        }
        ccc = n;
        rep(i, 0, n)
            solve(i);
        bool ok = false;
        was.clear();
        rep(i, 0, ccc)
        {
            if (dfs(i))
            {
                ok = true;
                break;
            }
        }
        for (int v : was)
            color[v] = prev[v] = prevEdge[v] = 0;
        //cout << "ok " << ok << endl;
        if (!ok)
            cout << -1 << "\n";
    }
    return 0;
}
