#include <bits/stdc++.h>

using namespace std;

struct Edge {
    int u, v, c;
    int id;

    Edge(int u, int v, int c, int id) : u(u), v(v), c(c), id(id) {}

    Edge() {}
};

int n, m;
vector<vector<Edge>> gr, gr_r;
vector<vector<int>> gr1;
int n1;

int add_vert() {
    gr1.push_back(vector<int>());
    n1++;
    return n1 - 1;
}

void add_edge(int u, int v) {
    gr1[u].push_back(v);
}

vector<int> used;
vector<int> st;

int dfs(int u) {
    used[u] = 1;
    st.push_back(u);
    for (int v : gr1[u]) {
        if (used[v] == 1) {
            return v;
        }
        if (used[v] == 0) {
            int x = dfs(v);
            if (x != -1) {
                return x;
            }
        }
    }
    used[u] = 2;
    st.pop_back();
    return -1;
}

int main() {
#ifdef DEBUG
    freopen("input", "r", stdin);
#endif

    int tt;
    scanf("%d", &tt);
    while (tt--) {
        scanf("%d%d", &n, &m);
        gr.resize(n);
        gr_r.resize(n);
        for (int i = 0; i < n; i++) {
            gr[i].clear();
            gr_r[i].clear();
        }

        for (int i = 0; i < m; i++) {
            int u, v, c;
            scanf("%d%d%d", &u, &v, &c);
            u--;
            v--;
            c--;

            gr[u].push_back(Edge(u, v, c, i));
            gr_r[v].push_back(Edge(u, v, c, i));
        }

        gr1.clear();
        n1 = 0;

        for (int i = 0; i < m; i++) {
            add_vert();
        }

        for (int i = 0; i < n; i++) {
            vector<int> ts;
            for (auto e : gr[i]) {
                ts.push_back(e.c);
            }
            for (auto e : gr_r[i]) {
                ts.push_back(e.c);
            }
            sort(ts.begin(), ts.end());
            ts.resize(unique(ts.begin(), ts.end()) - ts.begin());

            unordered_map<int, int> tind;
            for (int j = 0; j < ts.size(); j++) {
                tind[ts[j]] = j;
            }

            vector<int> vs1, vs2;
            for (int j = 0; j < ts.size(); j++) {
                vs1.push_back(add_vert());
            }
            for (int j = 0; j < ts.size(); j++) {
                vs2.push_back(add_vert());
            }
            for (int j = 0; j + 1 < ts.size(); j++) {
                add_edge(vs1[j + 1], vs1[j]);
                add_edge(vs2[j], vs2[j + 1]);
            }

            for (auto e : gr_r[i]) {
                add_edge(e.id, vs1[tind[e.c]]);
                add_edge(e.id, vs2[tind[e.c]]);
            }

            for (auto e : gr[i]) {
                int ind = tind[e.c];
                if (ind != 0) {
                    add_edge(vs2[ind - 1], e.id);
                }
                if (ind + 1 < vs1.size()) {
                    add_edge(vs1[ind + 1], e.id);
                }
            }
        }

        used.assign(n1, 0);
        st.clear();
        int ok = -1;
        for (int i = 0; i < n1; i++) {
            if (used[i] == 0) {
                int x = dfs(i);
                if (x != -1) {
                    ok = x;
                    break;
                }
            }
        }

        if (ok != -1) {
            vector<int> cyc;
            while (st.back() != ok) {
                if (st.back() < m) {
                    cyc.push_back(st.back());
                }
                st.pop_back();
            }
            if (ok < m) {
                cyc.push_back(ok);
            }

            reverse(cyc.begin(), cyc.end());
            cout << cyc.size() << "\n";
            for (int i : cyc) {
                cout << i + 1 << " ";
            }
            cout << "\n";
        } else {
            cout << "-1\n";
        }
    }

    return 0;
}