#define _CRT_SECURE_NO_WARNINGS
#include <stdio.h>
#include <Windows.h>
#include <string>
#include <array>
#include <cmath>

#define TRU 1
#define FOLS 0
using BULL = BOOL;

UINT64 Gen( UINT Power, UINT Parity )
{
  UINT64 res;

  memset(&res, 0, sizeof(UINT64));

  for (UINT i = (Parity + Power) & 1; i < Power; i += 2)
    res += (UINT64)pow<UINT64>(10, i);

  return res;
}

UINT64 Improve( UINT64 N )
{
  std::array<UINT64, 19> Precompute{};
  std::string View = std::to_string(N);

  INT OldestEqual = -1;
  for (UINT i = 0; i < View.length(); i++)
    if (View[i] == View[i + 1])
    {
      OldestEqual = View.length() - i - 1;
      break;
    }

  if (OldestEqual == -1)
    return N;

  N += (UINT64)pow<UINT64>(10, OldestEqual - 1);
  N -= N % (UINT64)pow<UINT64>(10, OldestEqual - 1);
  if (N % (UINT64)pow<UINT64>(10, OldestEqual) == 0)
    N += Gen(OldestEqual - 1, 1);
  else
    N += Gen(OldestEqual - 1, 0);

  return Improve(N);
}

VOID main( VOID )
{
  UINT64 n;

  scanf("%I64d", &n);
  n++;

  printf("%I64d", Improve(n));

  exit(0);
}