import java.util.Random;
import java.util.Scanner;

public class Task_D {
	public static void main(String[] args) {
		Scanner in = new Scanner(System.in);
		int n = in.nextInt();
		int[] a = new int[n];
		for (int i = 0; i < n; i++) {
			a[i] = in.nextInt();
		}
		String s = in.next();
		int[] ans = new int[n];
		add(a[0]);
		for (int i = 1; i < n; i++) {
			if (s.charAt(i) == 'L') {
				ans[i] = root.size;
			} 
			add(a[i]);
			root = split(root, a[i]).s;
		}
		root = null;
		add(a[n - 1]);
		for (int i = n - 2; i >= 0; i--) {
			if (s.charAt(i) == 'R') {
				ans[i] = root.size;
			}
			add(a[i]);
			root = split(root, a[i]).s;
		}
		for (int i = 0; i < n; i++) {
			System.out.print(ans[i] + " ");
		}
		
	}
	
	static Node root = null;
	static Random rand = new Random();
	static class Node {
		int size;
		int key;
		int prior;
		Node l, r;
		public Node(int key) {
			this.size = 1;
			this.key = key;
			this.prior = rand.nextInt(Integer.MAX_VALUE);
			this.l = null;
			this.r = null;
		}
	}
	
	static class Pair {
		Node f,s;
		
		public Pair(Node f, Node s) {
			this.f = f;
			this.s = s;
		}
	}
	
	static int get_size(Node t) {
		if (t == null) {
			return 0;
		}
		return t.size;
	}
	static void update(Node t) {
		if (t == null) {
			return;
		}
		t.size = get_size(t.l) + get_size(t.r) + 1;
	}
	static Node merge(Node t1, Node t2) {
		if (t1 == null) {
			return t2;
		}
		if (t2 == null) {
			return t1;
		}
		if (t1.prior > t2.prior) {
			t1.r = merge(t1.r , t2);
			update(t1);
			return t1;
		} else {
			t2.l = merge(t1, t2.l);
			update(t2);
			return t2;
		}
	}
	static Pair split(Node t, int key) {
		if (t == null) {
			return new Pair(null, null);
		}
		if (key > t.key) {
			Pair p = split(t.r, key);
			t.r = p.f;
			update(t);
			p.f = t;
			return p;
		} else {
			Pair p = split(t.l, key);
			t.l = p.s;
			update(t);
			p.s = t;
			return p;
		}
	}
	static void add(int k) {
		Pair p = split(root, k);
		Pair p2 = split(p.s, k + 1);
		root = merge(p.f, merge(merge(p2.f, new Node(k)), p2.s));
		update(root);
	}
}
