#include <iostream>
#include <string>
#include <vector>

using namespace std;

int countNums(long long num) {
    if (num == 0)
        return 1;
    int i = 0;
    for (; num > 0; num /= 10) {
        ++i;
    }
    return i;
}

#define N 280

int process(int idx, vector<string> &old, vector<string> &newVec, int count, int alreadyIn = 0) {
    auto currentString = string("");
    int i;
    bool flag = true;
    auto oldAppendTemp = countNums(old.size()) + 3;
    auto newAppendTemp = countNums(count) + 3;
    for (i = idx; i < old.size(); ++i) {
        auto oldAppend = oldAppendTemp + countNums(i + 1);
        auto newAppend = newAppendTemp + countNums(alreadyIn + 1);
        if (currentString.size() + old[i].size() - oldAppend + newAppend > N) {
            flag = false;
            break;
        }
        currentString += old[i].substr(0, old[i].size() - oldAppend);
    }
    newVec.push_back(currentString);
    ++alreadyIn;

    if (!flag) {
        process(i, old, newVec, count, alreadyIn);
    }

    return count - alreadyIn;
}

int main() {
    int n;
    cin >> n;
    auto old = vector<string>(static_cast<unsigned long long int>(n));
    string dummy;
    getline(cin, dummy);
    for (auto i = 0; i < n; ++i) {
        getline(cin, old[i]);
    }
    auto newVec = vector<string>();
    int l = 0, r = n + 1;
    while (r - l > 1) {
        int m = (r + l) / 2;
        newVec.clear();
        int result = process(0, old, newVec, m);
        if (result == 0) {
            break;
        }
        if (result > 0) {
            r = m;
        } else {
            l = m;
        }
    }
    cout << newVec.size() << endl;
    for (auto i = 0; i < newVec.size(); ++i) {
        cout << newVec[i] << '(' << i + 1 << '/' << newVec.size() << ")\n";
    }
    return 0;
}
