import java.io.BufferedInputStream;
import java.io.InputStream;
import java.util.Arrays;
import java.util.Locale;
import java.util.Scanner;

public class CoderZTeamProject {

    public static void main(String[] args) {
        Locale.setDefault(Locale.US);
        Scanner scanner = new Scanner(System.in);

        int maxMustSleep = Integer.parseInt(scanner.nextLine());

        boolean[][] schedules = new boolean[5][9];

        for (int a = 0; a < schedules.length; a++) {
            char[] schedule = scanner.nextLine().toCharArray();
            for (int b = 0; b < schedule.length; b++)
                schedules[a][b] = schedule[b] == '1';
        }

        int mustSleep = 0;
        int lastMustSleep = 0;
        int week = 1, day = 1;
        while (true) {
            for (boolean[] schedule : schedules) {
                mustSleep += 8;
                mustSleep -= getSleepTime(schedule);
                if (mustSleep >= maxMustSleep)
                    resolve(week, day);
                day++;
            }
            day = 1;
            mustSleep -= 4;
            if (mustSleep < 0) mustSleep = 0;
            if (mustSleep == lastMustSleep)
                reject();
            lastMustSleep = mustSleep;
            week++;
        }
    }

    private static void reject() {
        System.out.println(-1);
        System.exit(0);
    }

    private static void resolve(int a, int b) {
        System.out.println(a + " " + b);
        System.exit(0);
    }
    private static int getSleepTime(boolean[] schedule) {
        int result = 6;
        int index = 0;
        while (index < schedule.length && !schedule[index])
            index++;
        result += index;
        return result;
    }
}
